/*
* Copyright (C) 2013 Symphony Teleca Corp.
*
* Contact: Souparna Lodh <souparna.lodh(at)symphonyteleca.com>
*	
* This file is part of Open Source Doubango Framework.
*
* DOUBANGO is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*	
* DOUBANGO is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*	
* You should have received a copy of the GNU General Public License
* along with DOUBANGO.
*
*/

/**@file tdav_codec_fsl_vpu_h263.h
 * @brief H.263-1996 and H.263-1998 codec plugins from Freescale VPU Libraries.
 * RTP payloader follows RFC 4629 for H263+ and RFC 2190 for H263.
 *
 * @author Souparna Lodh <souparna.lodh(at)symphonyteleca.com>
 *

 */
#ifndef TINYDAV_CODEC_VPU_H263_H
#define TINYDAV_CODEC_VPU_H263_H

#include "tinydav_config.h"

#include "tinymedia/tmedia_codec.h"

TDAV_BEGIN_DECLS

TINYDAV_GEXTERN const tmedia_codec_plugin_def_t *tdav_codec_fsl_vpu_h263_plugin_def_t;

TDAV_END_DECLS

#endif /* TINYDAV_CODEC_VPU_H263_H */
